        include "tios.h"
        include "gray4lib.h"
        include "util.h"
        include "hufflib.h"

        xdef _main
        xdef _comment
        xdef _ti89

_main:
        jsr gray4lib::on
        move.l #titlePicBits,a0
        move.l #screensave0,a1
        move.w #0,d3
        jsr hufflib::extract
        bsr restoreScreen
        jsr util::idle_loop
        jsr gray4lib::off
        rts

restoreScreen:
        move.l d0,-(a7)
        move.l gray4lib::plane0,a0
        move.l #screensave0,a1
        move.l #LCD_HEIGHT-1,d0
restoreScreenLoop0:
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        add.l #10,a0
        dbra d0,restoreScreenLoop0
        move.l gray4lib::plane1,a0
        move.l #screensave1,a1
        move.l #LCD_HEIGHT-1,d0
restoreScreenLoop1:
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        move.l (a1)+,(a0)+
        add.l #10,a0
        dbra d0,restoreScreenLoop1
        move.l (a7)+,d0
        rts

titlePicBits:
        incbin "graytest.huf"

_comment dc.b "Grayscale test program",0

        bss
screensave0 ds.b 2000
screensave1 ds.b 2000

        end
