// Links an AmigaDOS object file and outputs a .9XZ file with the
// PlusShell format.
// Written by Rusty Wagner for PlusShell

#include <stdio.h>
#include "makebin.h"
#include "make9xz.h"
#include "make89z.h"

int main(int argc,char *argv[])
{
        FILE *fp,*out;
        char str[256];
        int len,i,j,ofs,type,k,lib,fnc,n,t;

        if (argc<2)
        {
                printf("Usage: MAKE9XZ [-b] ObjectName (without extension)\n");
                printf("        -b  Input is a raw .bin file\n");
                return 1;
        }
        if (strcmp(argv[1],"-b"))
        {
                if (makebin(argv[1])) return 1;
                if (output92plus) if (make9xz(argv[1])) return 1;
                if (output89) if (make89z(argv[1])) return 1;
        }
        else if (argc==3)
        {
                if (make9xz(argv[2])) return 1;
                if (make89z(argv[2])) return 1;
        }
        else
        {
                printf("No input file specified\n");
                return 1;
        }
        return 0;
}

